// Borland C++ Builder
// Copyright (c) 1995, 2005 by Borland Software Corporation
// All rights reserved

// (DO NOT EDIT: machine generated header) 'Acanimationeffect.pas' rev: 10.00

#ifndef AcanimationeffectHPP
#define AcanimationeffectHPP

#pragma delphiheader begin
#pragma option push
#pragma option -w-      // All warnings off
#pragma option -Vx      // Zero-length empty class member functions
#pragma pack(push,8)
#include <System.hpp>	// Pascal unit
#include <Sysinit.hpp>	// Pascal unit
#include <Windows.hpp>	// Pascal unit
#include <Messages.hpp>	// Pascal unit
#include <Classes.hpp>	// Pascal unit
#include <Acclasses.hpp>	// Pascal unit

//-- user supplied -----------------------------------------------------------

namespace Acanimationeffect
{
//-- type declarations -------------------------------------------------------
struct TMathPoint
{
	
public:
	float X;
	float Y;
} ;

struct TMatrix
{
	
public:
	float M11;
	float M12;
	float M13;
	float M21;
	float M22;
	float M23;
	float M31;
	float M32;
	float M33;
} ;

struct TSpikeData
{
	
public:
	TMathPoint TriangleEnd[3][16];
	TMathPoint EndCenter[16];
	TMathPoint TriangleCenter[16];
	TMatrix MatrixCircle[16];
} ;

#pragma option push -b-
enum TacAnimationType { atInit, atDraw, atErase };
#pragma option pop

#pragma option push -b-
enum TacAnimationEffectType { etRandom, etSpin, etVortex, etScatterGather, etSpike, etFireworks };
#pragma option pop

class DELPHICLASS TacAnimationEffect;
class PASCALIMPLEMENTATION TacAnimationEffect : public Acclasses::TacFormAnimationEffect 
{
	typedef Acclasses::TacFormAnimationEffect inherited;
	
private:
	Word FDelay;
	Byte FFrames;
	Byte FFireworkBlasts;
	TacAnimationEffectType FEffectType;
	Byte FSteps;
	HDC DrawDC;
	float EffectParam;
	TMatrix GlobalMatrix;
	TMathPoint FireworksData[256];
	int AfterImages;
	int TotalSteps;
	int Step;
	TMathPoint RightTop;
	TMathPoint Center;
	TSpikeData SpikeData;
	TacAnimationEffectType CurrentEffect;
	void __fastcall Animate(bool Open);
	void __fastcall AnimationSelect(TacAnimationType AnimationType);
	void __fastcall efSpinFrame(TacAnimationType AnimationType);
	void __fastcall efVortexFrames(TacAnimationType AnimationType);
	void __fastcall efScatterGatherFrames(TacAnimationType AnimationType);
	void __fastcall efSpikeFrames(TacAnimationType AnimationType);
	void __fastcall efFireworxFrames(TacAnimationType AnimationType);
	
protected:
	virtual void __fastcall DoAnimateOnShow(void);
	virtual void __fastcall DoAnimateOnHide(void);
	
public:
	__fastcall virtual TacAnimationEffect(Classes::TComponent* aOwner);
	void __fastcall Open(void);
	void __fastcall Close(void);
	
__published:
	__property AnimateOnShow  = {default=0};
	__property AnimateOnHide  = {default=0};
	__property Word Delay = {read=FDelay, write=FDelay, default=100};
	__property Byte FireworkBlasts = {read=FFireworkBlasts, write=FFireworkBlasts, default=10};
	__property Byte Frames = {read=FFrames, write=FFrames, default=6};
	__property TacAnimationEffectType EffectType = {read=FEffectType, write=FEffectType, default=0};
	__property Byte Steps = {read=FSteps, write=FSteps, default=50};
public:
	#pragma option push -w-inl
	/* TacFormHookComponent.KreateHook */ inline __fastcall TacAnimationEffect(Classes::TComponent* aOwner, Controls::TWinControl* aHookedObject) : Acclasses::TacFormAnimationEffect(aOwner, aHookedObject) { }
	#pragma option pop
	#pragma option push -w-inl
	/* TacFormHookComponent.Destroy */ inline __fastcall virtual ~TacAnimationEffect(void) { }
	#pragma option pop
	
};


//-- var, const, procedure ---------------------------------------------------
static const Shortint DEF_AE_DELAY = 0x64;
static const Shortint DEF_AE_FIREWORKBLASTS = 0xa;
static const Shortint DEF_AE_FRAMES = 0x6;
static const Shortint DEF_AE_STEPS = 0x32;

}	/* namespace Acanimationeffect */
using namespace Acanimationeffect;
#pragma pack(pop)
#pragma option pop

#pragma delphiheader end.
//-- end unit ----------------------------------------------------------------
#endif	// Acanimationeffect
